$(document).ready(function() {
    var colorsUrl = 'http://127.0.0.1/colors.json';

    /**
     * Defines and returns the AJAX request, for later specifiying
     * the handlers for success and failure.
     */
    function getAjaxRequest() {
        return $.ajax({
            url: colorsUrl,
            dataType: 'json',
            type: 'GET',
        });
    }

    /**
     * Called on AJAX request success, iterates through the response
     * data, creating an "option" value for each color, and appending
     * each element into the datalist element defined in the HTML.
     */
    function loadDatalist(responseData) {
        var datalist = $('#color-datalist');

        for (var colorIndex in responseData) {
            color = responseData[colorIndex];

            var option = $(
                '<option>',
                { value: color }
            );

            datalist.append(option);
        }
    }

    /**
     * Called on AJAX request error.
     */
    function handleRequestError(xhr, status) {
        alert('An error occurred in the AJAX request.');
    }

    getAjaxRequest().done(loadDatalist);
    getAjaxRequest().fail(handleRequestError);
});
